//--
//--	animwind.h
//--
//--	TBitmapAnimatorWindow Class Header File
//--


#if !defined(__ULU_ANIMATE_H)
#define __ULU_ANIMATE_H


// Make sure we have definitions for all types we use
#if !defined(OWL_MODULE_H)
	#include <owl\module.h>
#endif
#if !defined(OWL_POINT_H)
	#include <owl\point.h>
#endif
#if !defined(OWL_DC_H)
	#include <owl\dc.h>
#endif
#if !defined(OWL_GDIOBJEC_H)
	#include <owl\gdiobjec.h>
#endif
#if !defined(OWL_WINDOW_H)
	#include <owl\window.h>
#endif
#if !defined(__ULU_WINGDC_H)
	#include "wingdc.h"
#endif
#if !defined(__ULU_PALETTE_H)
	#include "palette.h"
#endif

typedef struct tagOFFSCREENBUFFERHEADER
{
	BITMAPINFOHEADER Header;
	RGBQUAD aColors[256];
}  OFFSCREENBUFFERHEADER;

class TBitmapAnimatorWindow : public TWindow
{
	private:
	protected:
		int nWidth, nHeight;
		TWinGDC *pBufferDC;
		TClientDC *pClientDC;
		TIdentityPalette *pPalette;
		HBITMAP hbmOldMonoBitmap;
		OFFSCREENBUFFERHEADER BufferHeader;
		void far *pOffScreenBits;
		long lBMPOrientation;
		TRect DirtyRect;
		//
		void RefreshScreen();
		HBITMAP BuildOffScreenDIB(int nXSize, int nYSize);
		void RebuildOffScreenDIB(int nXSize, int nYSize);
		// Derived classes should override these
		virtual void InitPalette()  {}
		virtual void DrawForeground(TRect &);
		virtual void DrawBackground(TRect &);
		// TWindow overrides
		virtual char *GetClassName()  {return "BitmapAnimatorWindow";}
		virtual void GetWindowClass(WNDCLASS &);
		virtual void SetupWindow();
		virtual void CleanupWindow();
		virtual void Paint(TDC &, bool, TRect &);
		// Message Handlers
		void EvSize(uint, TSize &);
		void EvPaletteChanged(HWND);
		bool EvQueryNewPalette();
	public:
		TBitmapAnimatorWindow(TWindow *pParWnd,
										const char far * = 0, TModule * = 0);
		virtual ~TBitmapAnimatorWindow();

		operator HDC()  {return (HDC)*pClientDC;}

		TDC *GetWinGDC()  {return pBufferDC;}

		BOOL TransparentDIBits(int nXOriginDest, int nYOriginDest,
							  TDib *pSrcDIB, unsigned char TransparentColor);

	DECLARE_RESPONSE_TABLE(TBitmapAnimatorWindow);
};

//----------------------------------------------
//  TBitmapAnimatorWindow::TransparentDIBits()
//----------------------------------------------
extern "C" BOOL far _ASM_TransCopyDIBBits(long lDrawX, long lDrawY,
					long lSrcWidth, long lSrcHeight, BYTE huge *hpSrcBits,
					long lDstWidth, long lDstHeight, BYTE huge *hpDstBits,
								  long lOrientation, BYTE bTransparentColor);


inline BOOL TBitmapAnimatorWindow::TransparentDIBits(int nXOriginDest,
											  int nYOriginDest,
											  TDib *pSrcDIB,
											  unsigned char TransparentColor)
{
	return _ASM_TransCopyDIBBits(nXOriginDest,nYOriginDest,
									pSrcDIB->Width(),pSrcDIB->Height(),
									(BYTE huge *)pSrcDIB->GetBits(),
									nWidth,nHeight,
									(BYTE huge *)pOffScreenBits,
									lBMPOrientation,TransparentColor);
}


#endif  //  #if !defined(__ULU_ANIMATE_H)

