//--
//--	dogwind.h
//--
//--	TDogWindow Class Header File
//--


#if !defined(__ULU_DOGWIND_H)
#define __ULU_DOGWIND_H


// Make sure we have definitions for all types we use
#if !defined(OWL_MODULE_H)
	#include <owl\module.h>
#endif
#if !defined(OWL_POINT_H)
	#include <owl\point.h>
#endif
#if !defined(OWL_GDIOBJEC_H)
	#include <owl\gdiobjec.h>
#endif
#if !defined(OWL_WINDOW_H)
	#include <owl\window.h>
#endif
#if !defined(__ULU_ANIMWIND_H)
	#include "animwind.h"
#endif


class TDogWindow : public TBitmapAnimatorWindow
{
	private:
	protected:
		TMemoryDC *pBkgndDC;
		TBitmap *pBkgndBitmap;
		TDib *pSpriteDIB;
		TRect BkgndRect, SpriteRect;
		// TBitmapAnimatorWindow overrides
		void SetupWindow();
		void CleanupWindow();
		virtual void InitPalette();
		virtual void DrawForeground(TRect &);
		virtual void DrawBackground(TRect &);
		// Message Handlers
		void EvLButtonDown(uint, TPoint &);
		void EvSize(uint, TSize &);
	public:
		TDogWindow(TWindow *, const char far * = 0, TModule * = 0);
		virtual ~TDogWindow();

	DECLARE_RESPONSE_TABLE(TDogWindow);
};



#endif  //  #if !defined(__ULU_DOGWIND_H)
